/*****************************************************************************
* Time Bomb example (FSM)
*
* Copyright (c) 2006 Miro Samek. All rights reserved.
*
* Email: miro@quantum-leaps.com
* Web:   www.quantum-leaps.com
*****************************************************************************/
#ifndef bomb_h
#define bomb_h

enum BombSignals {
    ARM_SIG = Q_USER_SIG
};

#define PULSE_PRIO   1
#define BOMB_PRIO    2

typedef struct BombTag Bomb;
struct BombTag {
    QActive super_;                                  /* derive from QActive */
    QEvent queue__[1];                                       /* event queue */
    uint8_t timeout__;                              /* timeout for the bomb */
    uint8_t ctr__;                                      /* internal counter */
};
void Bomb_init(Bomb *me, uint8_t timeout);

typedef struct PulseTag Pulse;
struct PulseTag {
    QActive super_;                                  /* derive from QActive */
    QEvent queue__[1];                                       /* event queue */
    uint8_t brightness__;                             /* current brightness */
    uint8_t timeout__;           /* timeout between changing the brightness */
};
void Pulse_init(Pulse *me, uint8_t freq);

#endif                                                            /* bomb_h */
