/*****************************************************************************
* Time Bomb example (FSM)
*
* Copyright (c) 2006 Miro Samek. All rights reserved.
*
* Email: miro@quantum-leaps.com
* Web:   www.quantum-leaps.com
*****************************************************************************/
#include "qpn_port.h"
#include "bsp.h"
#include "bomb.h"

static Bomb   l_bomb;
static QEvent l_bombQueue[1];

static Pulse  l_pulse;
/* no queue buffer */

/*..........................................................................*/
QActiveCB const Q_ROM QF_active[] = {
    { (QActive *)0,        (QEvent *)0, 0                  },     /* unused */
    { (QActive *)&l_pulse, (QEvent *)0, 0                  }, /* PULSE_PRIO */
    { (QActive *)&l_bomb,  l_bombQueue, Q_DIM(l_bombQueue) }   /* BOMB_PRIO */
};
uint8_t const Q_ROM QF_activeNum = Q_DIM(QF_active) - 1;   /* number of AOs */

/*..........................................................................*/
void main (void) {
    BSP_init();                                     /* initialize the board */

    Pulse_init(&l_pulse, 10);               /* init with freq of ramps [Hz] */
    Bomb_init(&l_bomb, 5);                    /* init with timeout in [sec] */

    QF_run();                                /* transfer control to QF-nano */
}
