/*****************************************************************************
* Time Bomb example (FSM)
*
* Copyright (c) 2006 Miro Samek. All rights reserved.
*
* Email: miro@quantum-leaps.com
* Web:   www.quantum-leaps.com
*****************************************************************************/
#ifndef qpn_port_h
#define qpn_port_h


#define Q_ROM                   code

#define Q_PARAM_SIZE            1

#define QF_TIMEEVT_CTR_SIZE     1

#define Q_NHSM
#define QF_FSM_ACTIVE

#define QF_MAX_ACTIVE           4

             /* interrupt locking policy for C8051F300/1/2/3/4/5, see NOTE01*/
#define QF_INT_LOCK()          (EA = 0, EA = 0)
#define QF_INT_UNLOCK()        (EA = 1)

#include <c8051f300.h>                                  /* SFR declarations */
#include "qpn.h"           /* QP-nano platform-independent public interface */

#endif                                                        /* qpn_port_h */

/*****************************************************************************
* NOTE01:
* According to the C8051F300/1/2/3/4/5 Manual, clearing the EA bit must always
* be followed by another 2-byte opcode ("C8051F300/1/2/3/4/5 Manual", Sec 8.3)
*/
